--[[------------------------------------------]]--
--[[--LostTreasures.lua						--]]--
--[[------------------------------------------]]--
LostTreasures = LibStub("AceAddon-3.0"):NewAddon("LostTreasures", "AceEvent-3.0", "AceConsole-3.0")

AceConfigRegistry = LibStub("AceConfigRegistry-3.0")
AceConfigDialog = LibStub("AceConfigDialog-3.0")


--[[------------------------------------------]]--
--[[--Event Handler							--]]--
--[[------------------------------------------]]--
function LostTreasures:PLAYER_LOGIN(event)
	self:UnregisterEvent(event)
	if ( _LT.SavedVars.ENABLED ) then
		LostTreasures:MapAllWaypoints()
		LostTreasures:SetClosestWaypoint()
	end
end
LostTreasures:RegisterEvent("PLAYER_LOGIN")

function LostTreasures:QUEST_FINISHED(event)
	if ( _LT.SavedVars.ENABLED ) then
		LostTreasures:RemoveAllWaypoints()
		LostTreasures:MapAllWaypoints()
		LostTreasures:SetClosestWaypoint()
	end
end
LostTreasures:RegisterEvent("QUEST_FINISHED")

--[[------------------------------------------]]--
--[[--Core Functions						--]]--
--[[------------------------------------------]]--
function LostTreasures:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("LostTreasuresDB", _LT.Defaults)
	_LT.SavedVars = self.db.char
	
	self:RegisterChatCommand("lt", "HandleCommand")
	self:RegisterChatCommand("losttreasures", "HandleCommand")
end

function LostTreasures:HandleCommand(input)
	if ( input == "removeall" ) then
		if ( _LT.SavedVars.ENABLED ) then
			LostTreasures:RemoveAllWaypoints()
		end
	elseif ( input == "reload" ) then
		if ( _LT.SavedVars.ENABLED ) then
			LostTreasures:RemoveAllWaypoints()
			LostTreasures:MapAllWaypoints()
			LostTreasures:SetClosestWaypoint()
		end
	else
		InterfaceOptionsFrame_OpenToCategory(_LT.NAME)
		--LostTreasures:RemoveWaypoint(31399)
	end
end

_LT = {
	NAME = "LostTreasures", 
	VERSION = GetAddOnMetadata("LostTreasures", "Version"), 
	Defaults = {
		char = {
			ENABLED = true, 
			DEBUG = false, 
			USE_ARROW = true, 
			USE_MINIMAP = true, 
			USE_WORLDMAP = true,
			CLEARDISTANCE = 3, 
		}, 
	}, 
}