--[[------------------------------------------]]--
--[[--LostTreasures_Config.lua				--]]--
--[[------------------------------------------]]--
local options = {
	type = "group", 
	name = _LT.NAME.." v".._LT.VERSION, 
	args = {
		configBox = {
			type = "group", 
			order = 100, 
			guiInline = true, 
			name = "Addon Config", 
			args = {
				enabledCheckbox = {
					type = "toggle", 
					order = 1, 
					name = "Enable Addon", 
					desc = "Toggles the addon on or off.", 
					get = function()
						return _LT.SavedVars.ENABLED
					end, 
					set = function(_, value)
						_LT.SavedVars.ENABLED = value
						if ( _LT.SavedVars.ENABLED ) then
							LostTreasures:RemoveAllWaypoints()
							LostTreasures:MapAllWaypoints()
							LostTreasures:SetClosestWaypoint()
						else
							LostTreasures:RemoveAllWaypoints()
						end
					end, 
				}, 
--[[				debugCheckbox = {
					type = "toggle", 
					order = 2, 
					name = "Enable Debug", 
					desc = "Using debug will show debug messages and change the way waypoints are mapped.", 
					width = "double", 
					get = function()
						return _LT.SavedVars.DEBUG
					end, 
					set = function(_, value)
						_LT.SavedVars.DEBUG = value
					end, 
				}, 
]]
				navigationBox = {
					type = "group", 
					order = 3, 
					guiInline = true, 
					name = "Navigation Options", 
					args = {
						arrowCheckbox = {
							type = "toggle", 
							order = 1, 
							name = "Enable Arrow", 
							desc = "Using this will have the navigation arrow find the closest waypoint.", 
							width = "double", 
							get = function()
								return _LT.SavedVars.USE_ARROW
							end, 
							set = function(_, value)
								_LT.SavedVars.USE_ARROW = value
								if ( _LT.SavedVars.ENABLED ) then
									LostTreasures:RemoveAllWaypoints()
									LostTreasures:MapAllWaypoints()
									LostTreasures:SetClosestWaypoint()
								end
							end, 
						}, 
						worldMapCheckbox = {
							type = "toggle", 
							order = 2, 
							name = "Enable World Map", 
							desc = "Using this will show waypoints on the world map.", 
							width = "double", 
							get = function()
								return _LT.SavedVars.USE_WORLDMAP
							end, 
							set = function(_, value)
								_LT.SavedVars.USE_WORLDMAP = value
								if ( _LT.SavedVars.ENABLED ) then
									LostTreasures:RemoveAllWaypoints()
									LostTreasures:MapAllWaypoints()
									LostTreasures:SetClosestWaypoint()
								end
							end, 
						}, 
						miniMapCheckbox = {
							type = "toggle", 
							order = 3, 
							name = "Enable Minimap", 
							desc = "Using this will show waypoints on the minimap.", 
							width = "double", 
							get = function()
								return _LT.SavedVars.USE_MINIMAP
							end, 
							set = function(_, value)
								_LT.SavedVars.USE_MINIMAP = value
								if ( _LT.SavedVars.ENABLED ) then
									LostTreasures:RemoveAllWaypoints()
									LostTreasures:MapAllWaypoints()
									LostTreasures:SetClosestWaypoint()
								end
							end, 
						}, 
						clearDistanceSlider = {
							type = "range",
							order = 4,
							name = "Waypoint Clear Distance",
							desc = "This will allow you to change how close you have to get to a waypoint in order for it to be removed.\n\nOff - 0\nDefault - 3\nMax - 10\n\nYou must reload your UI in order for this to take effect.",
							width = "double",
							min = 1, max = 10, step = 1,
							get = function()
								return _LT.SavedVars.CLEARDISTANCE
							end,
							set = function(_, value)
								_LT.SavedVars.CLEARDISTANCE = value
							end,
						}, 
					}, 
				}, 
				reloadWaypointsButton = {
					type = "execute", 
					order = 4, 
					name = "Reload Waypoints", 
					func = function()
						if ( _LT.SavedVars.ENABLED ) then
							LostTreasures:RemoveAllWaypoints()
							LostTreasures:MapAllWaypoints()
							LostTreasures:SetClosestWaypoint()
						end
					end, 
				}, 
				reloadUIButton = {
					type = "execute", 
					order = 5, 
					name = "Reload UI", 
					func = function()
						ReloadUI()
					end, 
				}, 
			}, 
		}, 
	}, 
}
AceConfigRegistry:RegisterOptionsTable("LostTreasures", options)
AceConfigDialog:AddToBlizOptions("LostTreasures", _LT.NAME)