--[[------------------------------------------]]--
--[[--LostTreasures_Points.lua				--]]--
--[[------------------------------------------]]--
function LostTreasures:RemoveWaypoint(point)
	for zoneTT, waypointsTT in pairs(TomTom.waypoints) do
		for keyTT, waypointTT in pairs(waypointsTT) do
			for zoneLT, questIdsLT in pairs(LostTreasures.Waypoints) do
				for questIdLT, waypointLT in pairs(questIdsLT) do
					local title = waypointLT.title.."\n"..waypointLT.note
					if ( (waypointTT.title == title) and (questIdLT == point) ) then
						TomTom:RemoveWaypoint(waypointTT)
					end
				end
			end
		end
	end
end

function LostTreasures:RemoveAllWaypoints()
	for zoneTT, waypointsTT in pairs(TomTom.waypoints) do
		for keyTT, waypointTT in pairs(waypointsTT) do
			for zoneLT, questIdsLT in pairs(LostTreasures.Waypoints) do
				for questIdLT, waypointLT in pairs(questIdsLT) do
					local title = waypointLT.title.."\n"..waypointLT.note
					if ( waypointTT.title == title ) then
						TomTom:RemoveWaypoint(waypointTT)
					end
				end
			end
		end
	end
end

function LostTreasures:SetClosestWaypoint()
	if ( _LT.SavedVars.USE_ARROW ) then
		local found = LostTreasures:GetClosestWaypoint()
		if ( found ) then
			print(found.title)
			TomTom:SetCrazyArrow(found, TomTom.profile.arrow.arrival, found.title)
		end
	end
end

function LostTreasures:GetClosestWaypoint()
	local closest_waypoint = nil
	local closest_dist = nil
	for zoneTT, waypointsTT in pairs(TomTom.waypoints) do
		for keyTT, waypointTT in pairs(waypointsTT) do
			for zoneLT, questIdsLT in pairs(LostTreasures.Waypoints) do
				for questIdLT, waypointLT in pairs(questIdsLT) do
					local title = waypointLT.title.."\n"..waypointLT.note
					if ( waypointTT.title == title ) then
						local dist, x, y = TomTom:GetDistanceToWaypoint(waypointTT)
						if (dist and closest_dist == nil) or (dist and dist < closest_dist) then
							closest_dist = dist
							closest_waypoint = waypointTT
						end
					end
				end
			end
		end
	end
	if ( closest_dist ) then
		return closest_waypoint
	end
end

function LostTreasures:MapAllWaypoints()
	if ( GetCurrentMapContinent() == 6 ) then
		for zone, questIds in pairs(LostTreasures.Waypoints) do
			for questId, waypoint in pairs(questIds) do
				if ( IsQuestFlaggedCompleted(questId) == nil ) then
					for i = 1, #waypoint.coords, 3 do
						local tomTomConfig = {
							title = "", 
							crazy = false, 
							world = _LT.SavedVars.USE_WORLDMAP, 
							minimap = _LT.SavedVars.USE_MINIMAP, 
							silent = false, 
							persistent = false, 
							callbacks = {
								cleardistance = _LT.SavedVars.CLEARDISTANCE, 
							}, 
						}
						tomTomConfig.title = waypoint.title.."\n"..waypoint.note
						tomTomConfig.callbacks = TomTom:DefaultCallbacks(tomTomConfig.callbacks)
						TomTom:AddMFWaypoint(zone, 0, waypoint.coords[i] / 100, waypoint.coords[(i + 1)] / 100, tomTomConfig)
					end
				end
			end
		end
	end
end

-- /run print(IsQuestFlaggedCompleted(31396))
LostTreasures.Waypoints = {
	[862] = { -- Pandaria (Outside of an actual zone)
		[31396] = {
			title = "Ship's Locker", 
			note = "Underwater, in the haul of the sunken ship.", 
			confirmed = true, 
			coords = {
				70.1, 74.5, "spawn_point", 
			}, 
		}, 
	}, 
	[806] = { -- The Jade Forest
		[31402] = {
			title = "Ancient Jinyu Staff", 
			note = "Underwater in the river, near the coords.", 
			confirmed = true, 
			coords = {
				44.9, 64.6, "spawn_point", 
				45.5, 64.4, "spawn_point", 
				46.2, 71.2, "spawn_point", 
				46.4, 65.3, "spawn_point", 
				46.4, 70.1, "spawn_point", 
				47.1, 67.5, "spawn_point", 
			}, 
		}, 
		[31399] = {
			title = "Ancient Pandaren Mining Pick", 
			note = "Enter the mine at (46.0, 29.1).\nThe mining pick is located throughout the mine at coords.\nThis object appears to not flag the quest as completed when looted.", 
			confirmed = true, 
			coords = {
				46.0, 29.1, "cave_entrance", 
				43.8, 30.7, "spawn_point", 
				44.1, 27.0, "spawn_point", 
				44.2, 28.6, "spawn_point", 
				45.6, 29.5, "spawn_point", -- Confirmed coord
			}, 
		}, 
		[31400] = {
			title = "Ancient Pandaren Tea Pot", 
			note = "Sits on the little table at coords.", 
			confirmed = true, 
			coords = {
				26.2, 32.4, "spawn_point", 
			}, 
		}, 
		[31864] = {
			title = "Chest of Supplies", 
			note = "Sits between a small boat wreck and a large tree, next to a river.", 
			confirmed = true, 
			coords = {
				24.6, 53.21, "spawn_point", 
			}, 
		}, 
		[31403] = {
			title = "Hammer of Ten Thunders", 
			note = "Spawns (on the ground) leaning up against a statue.", 
			confirmed = true, 
			coords = {
				40.2, 13.7, "spawn_point", 
				41.2, 13.9, "spawn_point", 
				41.8, 17.6, "spawn_point", 
				42.0, 17.5, "spawn_point", -- Confirmed coord
				43.0, 11.6, "spawn_point", 
			}, 
		}, 
		[31307] = {
			title = "Jade Infused Blade", 
			note = "Look for and interact with a npc named, \"Jade Warrior Statue\".", 
			confirmed = true, 
			coords = {
				39.2, 46.6, "spawn_point", 
			}, 
		}, 
		[31401] = {
			title = "Lucky Pandaren Coin", 
			note = "Look in the little fountain.", 
			confirmed = true, 
			coords = {
				31.9, 27.8, "spawn_point", 
			}, 
		}, 
		[31865] = {
			title = "Offering of Rememberance", 
			note = "The item will be sitting right on the alter.", 
			confirmed = true, 
			coords = {
				46.3, 80.7, "spawn_point", 
			}, 
		}, 
		[31404] = {
			title = "Pandaren Ritual Stone", 
			note = "Located in the middle of the stone pillars.", 
			confirmed = true, 
			coords = {
				23.5, 35.0, "spawn_point", 
			}, 
		}, 
		[31866] = {
			title = "Stash of Gems", 
			note = "Enter the cave at (62.6, 26.7).\nThe stash is located on your right as you enter the cave at (62.4, 27.5).", 
			confirmed = true, 
			coords = {
				62.6, 26.7, "cave_entrance", 
				62.4, 27.5, "spawn_point", 
			}, 
		}, 
		[31397] = {
			title = "Wodin's Mantid Shanker", 
			note = "Sits in the fountain at coords. Make sure you look carefully, the water hides it very well.", 
			confirmed = true, 
			coords = {
				39.4, 7.2, "spawn_point", 
			}, 
		}, 
	}, 
	[807] = { -- Valley of the Four Winds
		[31284] = {
			title = "Ancient Pandaren Fishing Charm", 
			note = "Look for and interact with a npc named, \"Ghostly Pandaren Fisherman\".", 
			confirmed = false, 
			coords = {
				46.8, 24.6, "spawn_point", 
			}, 
		}, 
		[31292] = {
			title = "Ancient Pandaren Woodcutter", 
			note = "Look for and interact with a npc named, \"Ghostly Pandaren Craftsman\".\nHe is chopping down the tree at coords.", 
			confirmed = true, 
			coords = {
				45.4, 38.2, "spawn_point", 
			}, 
		}, 
		[31869] = {
			title = "Boat-Building Instructions", 
			note = "In the house just north of the boat that is in the water.", 
			confirmed = true, 
			coords = {
				92.2, 39.5, "spawn_point", 
			}, 
		}, 
		[31406] = {
			title = "Cache of Pilfered Goods", 
			note = "Located inside of the virmen infested tunnel.", 
			confirmed = true, 
			coords = {
				43.6, 37.4, "spawn_point", 
			}, 
		}, 
		[31407] = {
			title = "Staff of the Hidden Master", 
			note = "The staff is sitting on the ground against the trunk of the trees.", 
			confirmed = true, 
			coords = {
				15.0, 33.7, "spawn_point", -- Confirmed coord
				15.4, 29.1, "spawn_point", 
				17.5, 35.7, "spawn_point", 
				19.0, 42.5, "spawn_point", 
				19.1, 37.9, "spawn_point", 
				15.4, 29.2, "spawn_point", -- Possible spawn?
				17.0, 35.0, "spawn_point", -- Possible spawn?
				18.0, 42.0, "spawn_point", -- Possible spawn?
				18.9, 42.5, "spawn_point", -- Possible spawn?
			}, 
		}, 
		[31405] = {
			title = "Virmen Treasure Cache", 
			note = "Enter the cave at (23.2, 30.5).\nThe cache to the left as you enter the cave at (23.8, 28.5).", 
			confirmed = true, 
			coords = {
				23.2, 30.5, "cave_entrance", 
				23.8, 28.5, "spawn_point", 
			}, 
		}, 
	}, 
	[873] = { -- The Veiled Stair
		[31867] = {
			title = "Forgotten Lockbox", 
			note = "Located in the \"Tavern In The Mists\", on the upper floor.", 
			confirmed = true, 
			coords = {
				54.6, 71.2, "spawn_point", 
			}, 
		}, 
		[31428] = {
			title = "The Hammer of Folly", 
			note = "Located at the top of the mountain in front of a large stone plate.", 
			confirmed = true, 
			coords = {
				74.8, 76.4, "spawn_point", 
				75.0, 76.6, "spawn_point", 
			}, 
		}, 
	}, 
	[857] = { -- Krasarang Wilds
		[31410] = {
			title = "Equipment Locker", 
			note = "On the bottom floor (there are 2 floors under the deck) of the large ship at coords.", 
			confirmed = true, 
			coords = {
				42.4, 92.0, "spawn_point", 
			}, 
		}, 
		[31409] = {
			title = "Pandaren Fishing Spear", 
			note = "Sitting in the sand behind Uncle Deming.", 
			confirmed = true, 
			coords = {
				50.8, 49.3, "spawn_point", 
			}, 
		}, 
		[31411] = {
			title = "Recipe: Banana Infused Rum", 
			note = "Sits on the ship's deck at coords.\nThere is a rare monster here that is required for [Glorious!] aswell.", 
			confirmed = true, 
			coords = {
				52.3, 88.7, "spawn_point", 
			}, 
		}, 
		[31408] = {
			title = "Saurok Stone Tablet", 
			note = "Enter the cave at (70.5, 9.5).\nThe tablet is located in the cave at (75.1, 55.1).", 
			confirmed = true, 
			coords = {
				70.5, 9.5, "cave_entrance", 
				75.1, 55.1, "spawn_point", 
			}, 
		}, 
		[31863] = {
			title = "Stack of Papers", 
			note = "Sitting on the ground near a rock and some skeletons.", 
			confirmed = true, 
			coords = {
				52.1, 73.4, "spawn_point", 
			}, 
		}, 
	}, 
	[809] = { -- Kun-Lai Summit
		[31420] = {
			title = "Ancient Mogu Tablet", 
			note = "Enter the cave at (63.9, 50.0).\nThe tablet is located behind a mogu statue at (64.2, 45.1).", 
			confirmed = true, 
			coords = {
				63.9, 50.0, "cave_entrance", 
				64.2, 45.1, "spawn_point", 
			}, 
		}, 
		[31414] = {
			title = "Hozen Treasure Cache", 
			note = "Enter the cave at (59.4, 53.0).\nThe cache is located at (49.5, 59.4).", 
			confirmed = true, 
			coords = {
				50.3, 61.7, "cave_entrance", 
				49.5, 59.4, "spawn_point", 
			}, 
		}, 
		[31413] = {
			title = "Hozen Warrior Spear", 
			note = "Enter the cave at (52.8, 71.3).\nThe spear is located in the lowest part of the cave at (51.5, 74.0).", 
			confirmed = false, 
			coords = {
				52.8, 71.3, "cave_entrance", 
				51.5, 74.0, "spawn_point", 
			}, 
		}, 
		[31304] = {
			title = "Kafa Press", 
			note = "Enter the cave at (37.5, 78.0).\nLook for and interact with a npc named, \"Frozen Trail Packer\" at (35.2, 76.4)./nHe is in a large ice block, very easy to see.", 
			confirmed = true, 
			coords = {
				37.5, 78.0, "cave_entrance", 
				35.2, 76.4, "spawn_point", 
			}, 
		}, 
		[31418] = {
			title = "Lost Adventurer's Belongings", 
			note = "Up on a cliff at coords. There is a rare monster here that is required for [Glorious!] aswell.", 
			confirmed = true, 
			coords = {
				36.7, 79.8, "spawn_point", 
			}, 
		}, 
		[31868] = {
			title = "Mo-Mo's Treasure Chest", 
			note = "Enter the cave at (48.1, 73.0).\nThe chest is located at the back of the cave at (47.8, 73.4).", 
			confirmed = true, 
			coords = {
				48.1, 73.0, "cave_entrance", 
				47.8, 73.4, "spawn_point", 
			}, 
		}, 
		[31419] = {
			title = "Rikktik's Tick Remover", 
			note = "Enter the cave at (52.2, 50.8).\nThe tick remover is located on the statue at (52.5, 51.5).", 
			confirmed = true, 
			coords = {
				52.2, 50.8, "cave_entrance", 
				52.5, 51.5, "spawn_point", 
			}, 
		}, 
		[31412] = {
			title = "Sprite's Cloth Chest", 
			note = "Enter the cave at (72.9, 73.4).\nThe chest is located at the back of the cave at (74.7, 74.9).", 
			confirmed = true, 
			coords = {
				72.9, 73.4, "cave_entrance", 
				74.7, 74.9, "spawn_point", 
			}, 
		}, 
		[31416] = {
			title = "Statue of Xuen", 
			note = "Spawns underwater in a little lake at coords.", 
			confirmed = true, 
			coords = {
				72.0, 33.9, "spawn_point", 
			}, 
		}, 
		[31415] = {
			title = "Stolen Sprite Treasure", 
			note = "Enter the cave at (59.5, 52.9).\nThe treasure is located in the back of the cave at (41.4, 44.2).\nFollow the cave path, take a left at the first fork, take a right and up at the second fork and finally take a left and up at the third fork.", 
			confirmed = true, 
			coords = {
				59.5, 52.9, "cave_entrance", 
				41.4, 44.2, "spawn_point", 
			}, 
		}, 
		[31421] = {
			title = "Sturdy Yaungol Spear", 
			note = "", 
			confirmed = false, 
			coords = {
				70.0, 63.8, "spawn_point", 
				71.2, 62.6, "spawn_point", 
			}, 
		}, 
		[31417] = {
			title = "Tablet of Ren Yun", 
			note = "", 
			confirmed = false, 
			coords = {
				44.7, 52.4, "spawn_point", 
			}, 
		}, 
		[31422] = {
			title = "Terracotta Head", 
			note = "Just sitting on the ground.", 
			confirmed = true, 
			coords = {
				57.0, 75.5, "spawn_point", 
				57.8, 76.3, "spawn_point", 
				58.4, 73.5, "spawn_point", 
				59.2, 73.0, "spawn_point", 
				59.2, 74.5, "spawn_point", 
			}, 
		}, 
	}, 
	[810] = { -- Townlong Steppes
		[31427] = {
			title = "Abandoned Crate of Goods", 
			note = "Inside of a small tent at coords.", 
			confirmed = true, 
			coords = {
				62.8, 34.1, "spawn_point", 
			}, 
		}, 
		[31426] = {
			title = "Amber Encased Moth", 
			note = "Sitting on the ground at coords.", 
			confirmed = true, 
			coords = {
				65.8, 86.1, "spawn_point", 
			}, 
		}, 
		[31423] = {
			title = "Fragment of Dread", 
			note = "Enter the cave at (34.9, 63.1).\nThe fragment has many spawns in the cave, have fun with this one.", 
			confirmed = true, 
			coords = {
				34.9, 63.1, "cave_entrance", 
			}, 
		}, 
		[31424] = {
			title = "Hardened Sap of Kri'vess", 
			note = "Sitting on the ground at one of the many locations.", 
			confirmed = true, 
			coords = {
				50.9, 55.2, "spawn_point", 
				51.1, 57.3, "spawn_point", 
				52.0, 58.7, "spawn_point", 
				52.5, 57.7, "spawn_point", 
				52.6, 55.4, "spawn_point", 
				52.8, 56.2, "spawn_point", 
				52.8, 60.0, "spawn_point", 
				53.8, 61.4, "spawn_point", 
				53.9, 58.4, "spawn_point", 
				55.6, 54.1, "spawn_point", 
				56.0, 55.5, "spawn_point", -- Confirmed coord
				57.4, 56.7, "spawn_point", 
				57.5, 58.4, "spawn_point", 
				57.5, 58.5, "spawn_point", 
			}, 
		}, 
		[31425] = {
			title = "Yaungol Fire Carrier", 
			note = "Sitting on the ground at one of the coords.", 
			confirmed = true, 
			coords = {
				66.2, 44.7, "spawn_point", 
				66.8, 48.1, "spawn_point", -- Confirmed coord
			}, 
		}, 
	}, 
	[858] = { -- Dread Wastes
		[31438] = {
			title = "Blade of the Poisoned Mind", 
			note = "Near a cave entrance, hidden behind a bush.", 
			confirmed = false, 
			coords = {
				28.8, 41.9, "spawn_point", 
			}, 
		}, 
		[31433] = {
			title = "Blade of the Prime", 
			note = "Enter the cave at (66.7, 63.7).\nThe blade is located in the back of the cave at (66.3, 66.5).", 
			confirmed = false, 
			coords = {
				66.7, 63.7, "cave_entrance", 
				66.3, 66.5, "spawn_point", 
			}, 
		}, 
		[31436] = {
			title = "Bloodsoaked Chitin Fragment", 
			note = "Enter the cave at (25.7, 53.0).\nThe fragment is located in the back of the cave at (25.9, 50.3).", 
			confirmed = false, 
			coords = {
				25.7, 54.3, "cave_entrance", 
				25.9, 50.3, "spawn_point", 
			}, 
		}, 
		[31435] = {
			title = "Dissector's Staff of Mutation", 
			note = "Sitting on the little cliff at coords.", 
			confirmed = true, 
			coords = {
				30.2, 90.8, "spawn_point", 
			}, 
		}, 
		[31431] = {
			title = "Lucid Amulet of the Agile Mind", 
			note = "Sits on the ground by a formation of 5 rocks at coords.", 
			confirmed = true, 
			coords = {
				33.0, 30.1, "spawn_point", 
			}, 
		}, 
		[31430] = {
			title = "Malik's Stalwart Spear", 
			note = "Sticks out of the tree next to a rock at coords.", 
			confirmed = true, 
			coords = {
				48.7, 29.9, "spawn_point", 
			}, 
		}, 
		[31432] = {
			title = "Manipulator's Talisman", 
			note = "Look for and interact with a npc named, \"Glinting Rapana Whelk\".\nYeah, it's a snail.", 
			confirmed = true, 
			coords = {
				41.6, 64.6, "spawn_point", 
				42.0, 62.2, "spawn_point", 
				42.2, 63.6, "spawn_point", 
			}, 
		}, 
		[31434] = {
			title = "Swarming Cleaver of Ka'roz", 
			note = "", 
			confirmed = false, 
			coords = {
				56.7, 77.7, "spawn_point", 
			}, 
		}, 
		[31437] = {
			title = "Swarmkeeper's Medallion", 
			note = "Near a large rock in a foggy area.", 
			confirmed = false, 
			coords = {
				54.3, 56.5, "spawn_point", 
			}, 
		}, 
		[31666] = { -- Apparently there is two quests for this object? 31666 and/or 31429
			title = "Wind-Reaver's Dagger of Quick Strikes", 
			note = "Sitting on the ground underneath the bush at coords.", 
			confirmed = true, 
			coords = {
				71.8, 36.1, "spawn_point", 
			}, 
		}, 
	}, 
}